﻿package 
{
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import my.display.myCircle;
	import my.display.myColor;
	import my.display.myButton;
	import my.display.myRectangle;
	
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.net.navigateToURL;
	
	import org.flashdevelop.utils.FlashConnect;
	
    import flash.text.TextField;
    import flash.text.TextFieldAutoSize;
    import flash.text.TextFormat;

	/**
	 * projekt 01 - XML menu
	 * @author Andrej Novotný
	 */
	
	public class Main extends Sprite 
	{
		private var animation_is_running:Boolean = false;
		private var animation_speed:Number = 8;	// 	> 1
		private var movingCircle:myCircle;
		private var nx:Number;
		private var ny:Number;
		
		private var xmlLoader:URLLoader;
		private var xmlData:XML;
		
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			FlashConnect.trace("init");
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			// samotne funkcie
			var paramObj:Object = this.loaderInfo.parameters;
			
			// maly oranzovy kruzok umiestnim k prvej polozke
			movingCircle = new myCircle(13, new myColor(255, 153, 0).getColor(), 0.9);
			movingCircle.x = 40;
			movingCircle.y = 55;
			addChild(movingCircle);
			
			xmlLoader = new URLLoader();
			xmlLoader.addEventListener(Event.COMPLETE, LoadXML);
			xmlLoader.load(new URLRequest("menu.xml")); // nazov vstupneho suboru
		}
			
		// zavola sa po kliku na tlacidlo, POKUS s druhym parametrom na odovzdavanie cielovej URL... nefunguje
		private function onClickHandler(event:MouseEvent, redir:String = null):void {
			// posunie oranzovy kruzok
			var clickedObject:DisplayObject = event.target as DisplayObject;
			moveCircleTo(clickedObject.x, clickedObject.y);		
			if (!animation_is_running) {
				animation_is_running = true;
				addEventListener(Event.ENTER_FRAME, movingCircle_onEnterFrameHandler);
			}
			// presmeruje na ziadanu URL
			// var link:URLRequest = new URLRequest("http://www.stanek.sk/");
			var link:URLRequest = new URLRequest(redir);
			navigateToURL(link);
		}
		
		private function movingCircle_onEnterFrameHandler(event:Event):void {
			// z cviceni
			var newx:Number = (nx - movingCircle.x) / animation_speed;
			var newy:Number = (ny - movingCircle.y +15) / animation_speed;
			
			if ((Math.abs(newx) < 0.1) && (Math.abs(newy) < 0.1) ) {
				removeEventListener(Event.ENTER_FRAME, movingCircle_onEnterFrameHandler);
				animation_is_running = false;
				movingCircle.x = nx;
				movingCircle.y = ny +15;
			} else {
				movingCircle.x += newx; 
				movingCircle.y += newy;
			}
		}
		
		private function moveCircleTo(x:Number, y:Number):void {
			// nove pozicie pre kruzok
			nx = x;
			ny = y;
		}
		
		private function LoadXML(e:Event):void {
			// predpripravene funkcie
			xmlData = new XML(xmlLoader.data);
			ParseMenu(xmlData);			
		}
		
		private function ParseMenu(menuXML:XML):void {
			// trace("XML Output --DIRECT--");
			var linkList:XMLList = menuXML.link;
			var i:Number = 1;
			for each (var linkElement:XML in linkList) {
				
				// vytvorim button
				var color:myColor = new myColor(51, 102, 153);
				var rectangle:myRectangle = new myRectangle(0, 0, color.getColor(), 0.9);
				var button:myButton = new myButton(rectangle, onClickHandler, linkElement, linkElement.@redirect);
				addChild(button);
				button.x = 40;   
				button.y = i * 40;
				
				// increment premennej
				i += 1;
			}
			// trace("-------------------");
		}
		
	}
}