﻿package my.display 
{
	import flash.display.Loader;
	import flash.display.Shape;
	import flash.events.IOErrorEvent;
	import flash.net.URLRequest;
	import flash.events.Event;
	import flash.display.BitmapData;
	
	import flash.geom.Matrix;
	
	import org.flashdevelop.utils.FlashConnect;
	
	/**
	 * projekt 01 - XML menu - z cviceni
	 * @author Andrej Novotný
	 */
	
	public class myCircle extends Shape
	{
		private var radius:Number;
		private var fillColor:uint;
		private var fillAlpha:Number;
		
		private var textureURL:String;
		private var textureLoader:Loader;
		
		public function myCircle(radius:Number, fillColor:uint = 0xFF0000, fillAlpha:Number = 1.0, textureURL:String = null ) 
		{
			
			this.radius = radius;
			this.fillColor = fillColor;
			this.fillAlpha = fillAlpha;			
		
			this.textureURL = textureURL;

			if (textureURL != null) {
				
				textureLoader = new Loader();
				var request:URLRequest = new URLRequest(textureURL);
				
				textureLoader.contentLoaderInfo.addEventListener(Event.COMPLETE, onTextureLoaderCOMPLETEhandler);
				textureLoader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, onTextureLoaderIO_ERRORhandler);
				FlashConnect.trace("load");
				textureLoader.load(request);
				
			} else {
				this.graphics.beginFill(fillColor, fillAlpha);
				this.graphics.drawCircle(0, 0, radius);
				this.graphics.endFill();
			}
			
		}
		
		private function onTextureLoaderCOMPLETEhandler(event:Event):void {
			FlashConnect.trace("COMPLETE");
            var myBitmap:BitmapData = new BitmapData(textureLoader.width, textureLoader.height, false);
  
            myBitmap.draw(textureLoader);
            
            this.graphics.beginBitmapFill(myBitmap);
            this.graphics.drawCircle(0, 0, radius);
            this.graphics.endFill();
		}
		
		private function onTextureLoaderIO_ERRORhandler(event:IOErrorEvent):void {
			FlashConnect.trace("Chyba pri nahravani! (" + textureURL + ")");
		}
		
	}

}